﻿// Arduino Alarm Clock (c) Joe Pardue October 17, 2012
// Based on Arduino Volt Meter (c) Joe Pardue 8/20/09
// This is a quick and dirty conversion so 
// no telling what was left laying about.
//
// WARNING: This software is for playing with electricity. Electricity is 
// that stuff that jumps out of the clouds making a big boom and is more
// than capable of blasting a tree or golfer into blackened smoking bits.
// Even though this is intended for folks using low voltages, I have no 
// doubt someone somewhere will tie this to a kite with a metallic string and
// fly it in a thunder storm and then bless me out (if they survive) because
// their stuff got blown all to Hell. Forutnately I am protected by a level
// of personal assets below the threshold of even the hungriest ambulance
// chaser so I'm not too worried about getting sued, and anyway I'm so old
// now that I might actually enjoy becoming a Darwinian Fundamentalist and
// removing some folks from the gene pool.  
// 
//  This work is entirely by Joe Pardue (except for the major portions he
//  stole and forgot to attribute).
//
//  This software is not warrented in any way what-so-ever. It WILL screw
//  something up and will kill someone after doing serious property
//  damage. 
//
//  You've been warned. (Twice now) Ah, yes I feel much better now.
//
// Please post questions to www.AVRFreaks.net and if the thread title is clear,
// I might see it there, and if the question isn't clearly covered in the 
// associated documentation, I might even answer it.
//

// This code is extracted from ideas and code in my book: 
// "Virtual Serial Port Cookbook" that you can get from 
// either www.smileymicros.com or Amazon
// There is preview materials on my website that will take you 
// up to building a Simple Terminal program.

//
// Unplugging the USB while the serialPort is open can cause unpredictable
// behavior and may require the user to close and reopen the program.
//


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using PortSet;
using DUD; // Detect USB Disconnect

namespace AAC
{
    public partial class Form1 : Form
    {
        //PortSettings portSet = new PortSettings();

        bool portIsOpen = false;

        static Double maxVoltage = 5.0;
        static Double maxADC = 1023.0;
        Double VoltsPerADC = maxVoltage / maxADC;

        private USBDisconnectDetector usbDisconnectDetector = null;

        public Form1()
        {
            InitializeComponent();

            //label1.Visible = false;

            usbDisconnectDetector = new USBDisconnectDetector();
            usbDisconnectDetector.USBRemoved += new USBDisconnectDetectorEventHandler(OnUSBRemoved);

            this.TopMost = true; // Open it on top. Set to false in form load so that it doesn't stay on top

        }


        // Called by DriveDetector after removable device has been unpluged 
        private void OnUSBRemoved(object sender, USBDisconnectDetectorEventArgs e)
        {
            if (portIsOpen)// we think the port is open
            {
                //if (!serialPort1.IsOpen) // but it isn't
                //{
                    //timer1.Enabled = false;
                    serialPort1.Close();
                    serialPort1.Dispose();
                    //portSet.Close();

                    openPortToolStripMenuItem.Enabled = false;
                    portIsOpen = false;
                    richTextBoxReceive.Text = "USB unplugged.\nClosing the port.";
                //}
            }


            //MessageBox.Show("USB Disconnect");
            //label1.Visible = true;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Preset for Arduino
/*            portSet.selectedBaudrate = 19200;
            portSet.selectedDataBits = 8;
            portSet.selectedHandshaking = System.IO.Ports.Handshake.None;
            portSet.selectedParity = System.IO.Ports.Parity.None;
            portSet.selectedStopBits = System.IO.Ports.StopBits.One;

            //serialPort1.Open();
            serialPort1.BaudRate = portSet.selectedBaudrate;
            serialPort1.DataBits = portSet.selectedDataBits;
            serialPort1.Handshake = portSet.selectedHandshaking;
            serialPort1.Parity = portSet.selectedParity;
            serialPort1.StopBits = portSet.selectedStopBits;
*/
            //richTextBoxReceive.Text = "Input from Arduino\n";
            openPortToolStripMenuItem.Enabled = false;

            richTextBoxReceive.Text = "Communication with Arduino\n";

            labelTime.Text = DateTime.Now.ToLongTimeString();
            labelDate.Text = DateTime.Now.ToShortDateString();

            comboBoxSelectAlarm.SelectedIndex = 0;

            openSerialPort();

            this.TopMost = false; // Let it fall under other windows.
        }

        private void selectDeviceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openSerialPort();
        }
        
        private void openSerialPort()
        {
            PortSettings portSet = new PortSettings();
            
            //portSet.initializePortSettings();

            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
                serialPort1.Dispose();
                openPortToolStripMenuItem.Enabled = false;
                portIsOpen = false;
                MessageBox.Show("Attempted to select device when a device was open.");
            }
            else
            {

                // Preset for Arduino
                portSet.selectedBaudrate = 57600;
                portSet.selectedDataBits = 8;
                portSet.selectedHandshaking = System.IO.Ports.Handshake.None;
                portSet.selectedParity = System.IO.Ports.Parity.None;
                portSet.selectedStopBits = System.IO.Ports.StopBits.One;

                if (portSet.ShowDialog() == DialogResult.OK)
                {
                        serialPort1.PortName = portSet.selectedPort;
                        serialPort1.BaudRate = portSet.selectedBaudrate;
                        serialPort1.DataBits = portSet.selectedDataBits;
                        serialPort1.Handshake = portSet.selectedHandshaking;
                        serialPort1.Parity = portSet.selectedParity;
                        serialPort1.StopBits = portSet.selectedStopBits;

                        serialPort1.Open();
                        portIsOpen = true;

                        openPortToolStripMenuItem.Enabled = true;
                        openPortToolStripMenuItem.Text = "Close Port";
                }
                else
                {
                    if(serialPort1.IsOpen)
                    {
                        serialPort1.Close();
                        serialPort1.Dispose();
                        openPortToolStripMenuItem.Enabled = false;
                        portIsOpen = false;
                        richTextBoxReceive.Text = "Port Setting Failure.\nClosing the port.";
                    }
                }
            }
        }

        #region Receive functions

        // we want to have the serial port thread report back data received, but to display
        // that data we must create a delegate function to show the data in the richTextBox

        // define the delegate 
        public delegate void SetText();
        // define an instance of the delegate
        SetText setText;

        // create a string that will be loaded with the data received from the port
        public string str = "";
        // JWP 4/28/07 added public byte for receiving bytes
        public byte byt = 0;

        // note that this function runs in a separate thread and thus we must use a delegate in order
        // to display the results in the richTextBox.
        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
              // instantiate the delegate to be invoked by this thread
                setText = new SetText(mySetText);

                // load the data into the string
                try
                {
                    str = serialPort1.ReadLine();//.ReadExisting();
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("Error - port_DataReceived Exception: " + ex);
                }

                // invoke the delegate in the MainForm thread
                this.Invoke(setText);
        }

        // create a strings to hold the date and time from the Arduino
        public string date_str = "";
        public string time_str = "";



        // create the instance of the delegate to be used to write the received data to the richTextBox
        public void mySetText()
        {
            //int myADC = 0;
            //Double myVolts = 0;

            

            if (str.Contains("TIME"))
            {
                //richTextBoxReceive.Text += "Contains TIME\n";
                time_str = str.Substring(4);
                richTextBoxReceive.Text += "TIME: " + time_str + "\n";
            }
            else if(str.Contains("DATE"))
            {
                //richTextBoxReceive.Text += "Contains DATE\n";
                date_str = str.Substring(4);
                //richTextBoxReceive.Text += date_str + "\n";
            }
            else richTextBoxReceive.Text += "< " + str + "\n";// Show the received data in the text box


            
            // Convert received string to integer
            //int.TryParse(str, out myADC);

            // Calculate volts
            //myVolts = ((Double)myADC * VoltsPerADC);

            // Show voltage on label to two decimal places
            //labelTime.Text =  myVolts.ToString("0.00");
        }

        // This rigaramole is needed to keep the last received item displayed
        // it kind of flickers and should be fixed
        private void richTextBoxReceive_TextChanged_1(object sender, EventArgs e)
        {
            moveCaretToEnd();
        }

        private void moveCaretToEnd()
        {
            richTextBoxReceive.SelectionStart = richTextBoxReceive.Text.Length;
            richTextBoxReceive.SelectionLength = 0;
            richTextBoxReceive.ScrollToCaret();
        }

        #endregion


        private void openPortToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openPort();
        }

        private void openPort()
        {
            try
            {
                if (serialPort1.IsOpen)
                {
                    serialPort1.Close();
                    serialPort1.Dispose();
                    openPortToolStripMenuItem.Text = "Open Port";
                    portIsOpen = false;
                }
                else
                {
                    serialPort1.Open();
                    openPortToolStripMenuItem.Text = "Close Port";
                    portIsOpen = true;
                }
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Error - openPortToolStripMenuItem_Click Exception: " + ex);
            }
        }

        int showDate = 59;

        private void timer1_Tick(object sender, EventArgs e)
        {

            if (serialPort1.IsOpen)
            {
                string command = System.String.Empty;
                command = "Time!";
                serialPort1.WriteLine(command);

                if (showDate++ >= 60) // update once per minute to keep traffic down
                {
                    richTextBoxReceive.Text += "";// While debugging I found this necessary. I guess it provides a pause for the Time! to process
                    command = "Date!";
                    serialPort1.WriteLine(command);
                    showDate = 0;
                }

                labelArduinoTime.Text = time_str;
                labelArduinoDate.Text = date_str;

            }

            labelTime.Text = DateTime.Now.ToLongTimeString();
            labelDate.Text = DateTime.Now.ToShortDateString();
        }

        #region Button Click functions
        // Reset the Arduino
        // if you want to understand this, condider purchasing my 
        // Virtual Serial Port Cookbook from either www.smileymicros.com
        // or Amazon
                private void button1_Click(object sender, EventArgs e)
                {
                    if (serialPort1.IsOpen)
                    {
                        serialPort1.DtrEnable = true;
                        serialPort1.DtrEnable = false;
                        serialPort1.DtrEnable = true;
                    }

                }
        
        private void buttonSmileyLink_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("www.smileymicros.com");		
        }

        private void buttonSetDateTime_Click(object sender, EventArgs e)
        {
            richTextBoxReceive.Text += "> Set Arduino to PC Date Time\n";
            richTextBoxReceive.Text += DateTime.Now.ToString() + "\n";
            //serialPort1.WriteLine("P" + DateTime.Now.ToString()+'!');

            //TODO - Convert To UNIX time.
	        TimeSpan _UnixTimeSpan = (DateTime.Now - new DateTime(1970, 1, 1, 0, 0, 0));
            richTextBoxReceive.Text += "unixtime = " + _UnixTimeSpan.TotalSeconds.ToString() + "\n";
            serialPort1.WriteLine("P" + _UnixTimeSpan.TotalSeconds.ToString() + '!');
        }

        private void buttonSetAlarm_Click(object sender, EventArgs e)
        {
            string command = System.String.Empty;

            richTextBoxReceive.Text += "> Set Arduino " +
                comboBoxSelectAlarm.SelectedItem.ToString() + 
                " " + dateTimePicker2.Value.ToShortDateString() +
                " " + dateTimePicker1.Value.ToShortTimeString() +
               "\n";

            // Since this was written in 2012, there is no need to set alarms before that year
            // The rest of the vales have 0 added if they are less than 10 to facilitate
            // the Arduino command parsing.
            command = "A" + (comboBoxSelectAlarm.SelectedIndex + 1) +
                (dateTimePicker2.Value.Year - 2000);
            if (dateTimePicker2.Value.Month < 10)
            {
                command += "0" + dateTimePicker2.Value.Month;
            }
            else
            {
                command += dateTimePicker2.Value.Month;
            }
            if (dateTimePicker2.Value.Day < 10)
            {
                command += "0" + dateTimePicker2.Value.Day;
            }
            else
            {
                command += dateTimePicker2.Value.Day;
            }
            if (dateTimePicker1.Value.Hour < 10)
            {
                command += "0" + dateTimePicker1.Value.Hour;
            }
            else
            {
                command += dateTimePicker1.Value.Hour;
            }
            if (dateTimePicker1.Value.Minute < 10)
            {
                command += "0" + dateTimePicker1.Value.Minute;
            }
            else
            {
                command += dateTimePicker1.Value.Minute;
            }
            if (dateTimePicker1.Value.Second < 10)
            {
                command += "0" + dateTimePicker1.Value.Second;
            }
            else
            {
                command += dateTimePicker1.Value.Second;
            }
            command += "!";
            richTextBoxReceive.Text += "> " + command + "\n";
            serialPort1.WriteLine(command);

            // Show the alarm you just set
            if ((comboBoxSelectAlarm.SelectedIndex + 1) == 1)
            {
                labelAlarm1.Text = "Alarm 1 - " +
                    dateTimePicker2.Value.ToShortDateString() +
                    " " + dateTimePicker1.Value.ToShortTimeString();
            }
            else if ((comboBoxSelectAlarm.SelectedIndex + 1) == 2)
            {
                labelAlarm2.Text = "Alarm 2 - " +
                    dateTimePicker2.Value.ToShortDateString() +
                    " " + dateTimePicker1.Value.ToShortTimeString();
            }
            else if ((comboBoxSelectAlarm.SelectedIndex + 1) == 3)
            {
                labelAlarm3.Text = "Alarm 3 - " +
                    dateTimePicker2.Value.ToShortDateString() +
                    " " + dateTimePicker1.Value.ToShortTimeString();
            }
            else if ((comboBoxSelectAlarm.SelectedIndex + 1) == 4)
            {
                labelAlarm4.Text = "Alarm 4 - " +
                    dateTimePicker2.Value.ToShortDateString() +
                    " " + dateTimePicker1.Value.ToShortTimeString();
            }
            else if ((comboBoxSelectAlarm.SelectedIndex + 1) == 5)
            {
                labelAlarm5.Text = "Alarm 5 - " +
                    dateTimePicker2.Value.ToShortDateString() +
                    " " + dateTimePicker1.Value.ToShortTimeString();
            }
        }




        #endregion

        private void contextMenuStripReceive_MouseDown(object sender, MouseEventArgs e)
        {

        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxReceive.Copy();
        }

        private void cToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxReceive.Cut();
        }

        private void uToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxReceive.Clear();
        }

        private void selectAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxReceive.SelectAll();
        }

        private void saveFileAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string filename = "";
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                filename = saveFileDialog1.FileName;
                if (filename != "") richTextBoxReceive.SaveFile(filename, RichTextBoxStreamType.PlainText);
            }
        }

        private void richTextBoxReceive_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                contextMenuStripReceive.Show(MousePosition);
            }
        }

        private void buttonTest_Click(object sender, EventArgs e)
        {
            string command = System.String.Empty;
            command = "L!";
            richTextBoxReceive.Text += "> " + command + "\n";
            serialPort1.WriteLine(command);
        }

        private void buttonGetArduinoTime_Click(object sender, EventArgs e)
        {
            string command = System.String.Empty;
            command = "Time!";
            richTextBoxReceive.Text += "> " + command + "\n";
            serialPort1.WriteLine(command);

        }

        private void buttonGetArduinoDate_Click(object sender, EventArgs e)
        {
            string command = System.String.Empty;
            command = "Date!";
            richTextBoxReceive.Text += "> " + command + "\n";
            serialPort1.WriteLine(command);
        }

        private void buttonStopTimer_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled)
            {
                timer1.Enabled = false;
                buttonStopTimer.Text = "Start Timer";
            }
            else {
                timer1.Enabled = true;
                buttonStopTimer.Text = "Stop Timer";

            }
        }


    }
}
